Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.xssf.usermodel
Class XSSFCell

    java.lang.Object
      org.apache.poi.xssf.usermodel.XSSFCell

All Implemented Interfaces:
  org.apache.poi.ss.usermodel.Cell

    public final class XSSFCell

extends java.lang.Object
implements org.apache.poi.ss.usermodel.Cell

High level representation of a cell in a row of a spreadsheet.

Cells can be numeric, formula-based or string-based (text). The cell type specifies this. String cells cannot conatin numbers and numeric cells cannot contain strings (at least according to our model). Client apps should do the conversions themselves. Formula cells have the formula string, as well as the formula result, which can be numeric or string.

Cells should have their number (0 based) before being added to a row. Only cells that have values should be added.

Field Summary

Fields inherited from interface org.apache.poi.ss.usermodel.Cell
`CELL_TYPE_BLANK, CELL_TYPE_BOOLEAN, CELL_TYPE_ERROR, CELL_TYPE_FORMULA, CELL_TYPE_NUMERIC, CELL_TYPE_STRING`

Method Summary
`org.apache.poi.ss.util.CellRangeAddress` | `getArrayFormulaRange()`
`boolean` | `getBooleanCellValue()` Get the value of the cell as a boolean.
`int` | `getCachedFormulaResultType()` Only valid for formula cells
`org.apache.poi.ss.usermodel.Comment` | `getCellComment()` Returns cell comment associated with this cell
`java.lang.String` | `getCellFormula()` Return a formula for the cell, for example, `SUM(C4:E4)`
`org.apache.poi.ss.usermodel.CellStyle` | `getCellStyle()` Return the cell's style.
`int` | `getCellType()` Return the cell type.
`int` | `getColumnIndex()` Returns column index of this cell
`org.openxmlformats.schemas.spreadsheetml.x2006.main.CTCell` | `getCTCell()` Returns the xml bean containing information about the cell's location (reference), value, data type, formatting, and formula
`java.util.Date` | `getDateCellValue()` Get the value of the cell as a date.
`java.lang.String` | `getErrorCellString()` Returns the error message, such as #VALUE!
`byte` | `getErrorCellValue()` Get the value of the cell as an error code.
`org.apache.poi.ss.usermodel.Hyperlink` | `getHyperlink()` Returns hyperlink associated with this cell
`double` | `getNumericCellValue()` Get the value of the cell as a number.
`java.lang.String` | `getRawValue()` Returns the raw, underlying ooxml value for the cell
`java.lang.String` | `getReference()` Returns an A1 style reference to the location of this cell
`org.apache.poi.ss.usermodel.RichTextString` | `getRichStringCellValue()` Get the value of the cell as a XSSFRichTextString
`org.apache.poi.ss.usermodel.Row` | `getRow()` Returns the row this cell belongs to
`int` | `getRowIndex()` Returns row index of a row in the sheet that contains this cell
`org.apache.poi.ss.usermodel.Sheet` | `getSheet()` Returns the sheet this cell belongs to
`java.lang.String` | `getStringCellValue()` Get the value of the cell as a string
`boolean` | `isPartOfArrayFormulaGroup()`
`void` | `removeCellComment()` Removes the comment for this cell, if there is one.
`void` | `setAsActiveCell()` Sets this cell as the active cell for the worksheet.
`void` | `setCellComment(org.apache.poi.ss.usermodel.Comment comment)` Assign a comment to this cell.
`void` | `setCellErrorValue(byte errorCode)` Set a error value for the cell
`void` | `setCellErrorValue(org.apache.poi.ss.usermodel.FormulaError error)` Set a error value for the cell
`void` | `setCellFormula(java.lang.String formula)` Sets formula for this cell.
`void` | `setCellStyle(org.apache.poi.ss.usermodel.CellStyle style)` Set the style for the cell.
`void` | `setCellType(int cellType)` Set the cells type (numeric, formula or string)
`void` | `setCellValue(boolean value)` Set a boolean value for the cell
`void` | `setCellValue(java.util.Calendar value)` Set a date value for the cell.
`void` | `setCellValue(java.util.Date value)` Set a date value for the cell.
`void` | `setCellValue(double value)` Set a numeric value for the cell
`void` | `setCellValue(org.apache.poi.ss.usermodel.RichTextString str)` Set a string value for the cell.
`void` | `setCellValue(java.lang.String str)` Set a string value for the cell.
`void` | `setHyperlink(org.apache.poi.ss.usermodel.Hyperlink hyperlink)` Assign a hypelrink to this cell
`java.lang.String` | `toString()` Returns a string representation of the cell

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### getSheet

    public org.apache.poi.ss.usermodel.Sheet getSheet()

  Returns the sheet this cell belongs to

  Specified by:
    `getSheet` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the sheet this cell belongs to

### getRow

    public org.apache.poi.ss.usermodel.Row getRow()

  Returns the row this cell belongs to

  Specified by:
    `getRow` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the row this cell belongs to

### getBooleanCellValue

    public boolean getBooleanCellValue()

  Get the value of the cell as a boolean.

  For strings, numbers, and errors, we throw an exception. For blank cells we return a false.

  Specified by:
    `getBooleanCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the value of the cell as a boolean
  Throws:
    `java.lang.IllegalStateException` - if the cell type returned by `getCellType()` is not CELL_TYPE_BOOLEAN, CELL_TYPE_BLANK or CELL_TYPE_FORMULA

### setCellValue

    public void setCellValue(boolean value)

  Set a boolean value for the cell

  Specified by:
    `setCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `value` - the boolean value to set this cell to. For formulas we'll set the precalculated value, for booleans we'll set its value. For other types we will change the cell to a boolean cell and set its value.

### getNumericCellValue

    public double getNumericCellValue()

  Get the value of the cell as a number.

  For strings we throw an exception. For blank cells we return a 0. For formulas or error cells we return the precalculated value;

  Specified by:
    `getNumericCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the value of the cell as a number
  Throws:
    `java.lang.IllegalStateException` - if the cell type returned by `getCellType()` is CELL_TYPE_STRING
    `java.lang.NumberFormatException` - if the cell value isn't a parsable `double`.
  See Also:
    `for turning this number into a string similar to that which Excel would render this number as.`

### setCellValue

    public void setCellValue(double value)

  Set a numeric value for the cell

  Specified by:
    `setCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `value` - the numeric value to set this cell to. For formulas we'll set the precalculated value, for numerics we'll set its value. For other types we will change the cell to a numeric cell and set its value.

### getStringCellValue

    public java.lang.String getStringCellValue()

  Get the value of the cell as a string

  For numeric cells we throw an exception. For blank cells we return an empty string. For formulaCells that are not string Formulas, we throw an exception

  Specified by:
    `getStringCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the value of the cell as a string

### getRichStringCellValue

    public org.apache.poi.ss.usermodel.RichTextString getRichStringCellValue()

  Get the value of the cell as a XSSFRichTextString

  For numeric cells we throw an exception. For blank cells we return an empty string. For formula cells we return the pre-calculated value if a string, otherwise an exception

  Specified by:
    `getRichStringCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the value of the cell as a XSSFRichTextString

### setCellValue

    public void setCellValue(java.lang.String str)

  Set a string value for the cell.

  Specified by:
    `setCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `str` - value to set the cell to. For formulas we'll set the formula cached string result, for String cells we'll set its value. For other types we will change the cell to a string cell and set its value. If value is null then we will change the cell to a Blank cell.

### setCellValue

    public void setCellValue(org.apache.poi.ss.usermodel.RichTextString str)

  Set a string value for the cell.

  Specified by:
    `setCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `str` - value to set the cell to. For formulas we'll set the 'pre-evaluated result string, for String cells we'll set its value. For other types we will change the cell to a string cell and set its value. If value is null then we will change the cell to a Blank cell.

### getCellFormula

    public java.lang.String getCellFormula()

  Return a formula for the cell, for example, `SUM(C4:E4)`

  Specified by:
    `getCellFormula` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    a formula for the cell
  Throws:
    `java.lang.IllegalStateException` - if the cell type returned by `getCellType()` is not CELL_TYPE_FORMULA

### setCellFormula

    public void setCellFormula(java.lang.String formula)

  Sets formula for this cell.

  Note, this method only sets the formula string and does not calculate the formula value. To set the precalculated value use `setCellValue(double)` or `setCellValue(String)`

  Specified by:
    `setCellFormula` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `formula` - the formula to set, e.g. `"SUM(C4:E4)"`. If the argument is `null` then the current formula is removed.
  Throws:
    `org.apache.poi.ss.formula.FormulaParseException` - if the formula has incorrect syntax or is otherwise invalid
    `java.lang.IllegalStateException` - if the operation is not allowed, for example, when the cell is a part of a multi-cell array formula

### getColumnIndex

    public int getColumnIndex()

  Returns column index of this cell

  Specified by:
    `getColumnIndex` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    zero-based column index of a column in a sheet.

### getRowIndex

    public int getRowIndex()

  Returns row index of a row in the sheet that contains this cell

  Specified by:
    `getRowIndex` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    zero-based row index of a row in the sheet that contains this cell

### getReference

    public java.lang.String getReference()

  Returns an A1 style reference to the location of this cell

  Returns:
    A1 style reference to the location of this cell

### getCellStyle

    public org.apache.poi.ss.usermodel.CellStyle getCellStyle()

  Return the cell's style.

  Specified by:
    `getCellStyle` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the cell's style.

### setCellStyle

    public void setCellStyle(org.apache.poi.ss.usermodel.CellStyle style)

  Set the style for the cell. The style should be an XSSFCellStyle created/retreived from the XSSFWorkbook.

  Specified by:
    `setCellStyle` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `style` - reference contained in the workbook. If the value is null then the style information is removed causing the cell to used the default workbook style.

### getCellType

    public int getCellType()

  Return the cell type.

  Specified by:
    `getCellType` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the cell type
  See Also:
    `Cell.CELL_TYPE_BLANK`, `Cell.CELL_TYPE_NUMERIC`, `Cell.CELL_TYPE_STRING`, `Cell.CELL_TYPE_FORMULA`, `Cell.CELL_TYPE_BOOLEAN`, `Cell.CELL_TYPE_ERROR`

### getCachedFormulaResultType

    public int getCachedFormulaResultType()

  Only valid for formula cells

  Specified by:
    `getCachedFormulaResultType` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    one of (`Cell.CELL_TYPE_NUMERIC`, `Cell.CELL_TYPE_STRING`, `Cell.CELL_TYPE_BOOLEAN`, `Cell.CELL_TYPE_ERROR`) depending on the cached value of the formula

### getDateCellValue

    public java.util.Date getDateCellValue()

  Get the value of the cell as a date.

  For strings we throw an exception. For blank cells we return a null.

  Specified by:
    `getDateCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the value of the cell as a date
  Throws:
    `java.lang.IllegalStateException` - if the cell type returned by `getCellType()` is CELL_TYPE_STRING
    `java.lang.NumberFormatException` - if the cell value isn't a parsable `double`.
  See Also:
    `for formatting this date into a string similar to how excel does.`

### setCellValue

    public void setCellValue(java.util.Date value)

  Set a date value for the cell. Excel treats dates as numeric so you will need to format the cell as a date.

  Specified by:
    `setCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `value` - the date value to set this cell to. For formulas we'll set the precalculated value, for numerics we'll set its value. For other types we will change the cell to a numeric cell and set its value.

### setCellValue

    public void setCellValue(java.util.Calendar value)

  Set a date value for the cell. Excel treats dates as numeric so you will need to format the cell as a date.

  This will set the cell value based on the Calendar's timezone. As Excel does not support timezones this means that both 20:00+03:00 and 20:00-03:00 will be reported as the same value (20:00) even that there are 6 hours difference between the two times. This difference can be preserved by using `setCellValue(value.getTime())` which will automatically shift the times to the default timezone.

  Specified by:
    `setCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `value` - the date value to set this cell to. For formulas we'll set the precalculated value, for numerics we'll set its value. For othertypes we will change the cell to a numeric cell and set its value.

### getErrorCellString

    public java.lang.String getErrorCellString()

  Returns the error message, such as #VALUE!

  Returns:
    the error message such as #VALUE!
  Throws:
    `java.lang.IllegalStateException` - if the cell type returned by `getCellType()` isn't CELL_TYPE_ERROR
  See Also:
    `FormulaError`

### getErrorCellValue

    public byte getErrorCellValue()

  Get the value of the cell as an error code.

  For strings, numbers, and booleans, we throw an exception. For blank cells we return a 0.

  Specified by:
    `getErrorCellValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the value of the cell as an error code
  Throws:
    `java.lang.IllegalStateException` - if the cell type returned by `getCellType()` isn't CELL_TYPE_ERROR
  See Also:
    `FormulaError`

### setCellErrorValue

    public void setCellErrorValue(byte errorCode)

  Set a error value for the cell

  Specified by:
    `setCellErrorValue` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `errorCode` - the error value to set this cell to. For formulas we'll set the precalculated value , for errors we'll set its value. For other types we will change the cell to an error cell and set its value.
  See Also:
    `FormulaError`

### setCellErrorValue

    public void setCellErrorValue(org.apache.poi.ss.usermodel.FormulaError error)

  Set a error value for the cell

  Parameters:
    `error` - the error value to set this cell to. For formulas we'll set the precalculated value , for errors we'll set its value. For other types we will change the cell to an error cell and set its value.

### setAsActiveCell

    public void setAsActiveCell()

  Sets this cell as the active cell for the worksheet.

  Specified by:
    `setAsActiveCell` in interface `org.apache.poi.ss.usermodel.Cell`

### setCellType

    public void setCellType(int cellType)

  Set the cells type (numeric, formula or string)

  Specified by:
    `setCellType` in interface `org.apache.poi.ss.usermodel.Cell`
  Throws:
    `java.lang.IllegalArgumentException` - if the specified cell type is invalid
  See Also:
    `Cell.CELL_TYPE_NUMERIC`, `Cell.CELL_TYPE_STRING`, `Cell.CELL_TYPE_FORMULA`, `Cell.CELL_TYPE_BLANK`, `Cell.CELL_TYPE_BOOLEAN`, `Cell.CELL_TYPE_ERROR`

### toString

    public java.lang.String toString()

  Returns a string representation of the cell

  Formula cells return the formula string, rather than the formula result. Dates are displayed in dd-MMM-yyyy format Errors are displayed as #ERR<errIdx>

  Overrides:
    `toString` in class `java.lang.Object`

### getRawValue

    public java.lang.String getRawValue()

  Returns the raw, underlying ooxml value for the cell

  If the cell contains a string, then this value is an index into the shared string table, pointing to the actual string value. Otherwise, the value of the cell is expressed directly in this element. Cells containing formulas express the last calculated result of the formula in this element.

  Returns:
    the raw cell value as contained in the underlying CTCell bean, `null` for blank cells.

### getCellComment

    public org.apache.poi.ss.usermodel.Comment getCellComment()

  Returns cell comment associated with this cell

  Specified by:
    `getCellComment` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    the cell comment associated with this cell or `null`

### setCellComment

    public void setCellComment(org.apache.poi.ss.usermodel.Comment comment)

  Assign a comment to this cell. If the supplied comment is null, the comment for this cell will be removed.

  Specified by:
    `setCellComment` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `comment` - the XSSFComment associated with this cell

### removeCellComment

    public void removeCellComment()

  Removes the comment for this cell, if there is one.

  Specified by:
    `removeCellComment` in interface `org.apache.poi.ss.usermodel.Cell`

### getHyperlink

    public org.apache.poi.ss.usermodel.Hyperlink getHyperlink()

  Returns hyperlink associated with this cell

  Specified by:
    `getHyperlink` in interface `org.apache.poi.ss.usermodel.Cell`
  Returns:
    hyperlink associated with this cell or `null` if not found

### setHyperlink

    public void setHyperlink(org.apache.poi.ss.usermodel.Hyperlink hyperlink)

  Assign a hypelrink to this cell

  Specified by:
    `setHyperlink` in interface `org.apache.poi.ss.usermodel.Cell`
  Parameters:
    `hyperlink` - the hypelrink to associate with this cell

### getCTCell

    public org.openxmlformats.schemas.spreadsheetml.x2006.main.CTCell getCTCell()

  Returns the xml bean containing information about the cell's location (reference), value, data type, formatting, and formula

  Returns:
    the xml bean containing information about this cell

### getArrayFormulaRange

    public org.apache.poi.ss.util.CellRangeAddress getArrayFormulaRange()

  Specified by:
    `getArrayFormulaRange` in interface `org.apache.poi.ss.usermodel.Cell`

### isPartOfArrayFormulaGroup

    public boolean isPartOfArrayFormulaGroup()

  Specified by:
    `isPartOfArrayFormulaGroup` in interface `org.apache.poi.ss.usermodel.Cell`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD